# Library Statistics Web Service

This repository contains the source code for a RESTful web service written in Go. The service provides statistical data on books and readership by interfacing with the Gutendex API, Language2Countries API, and REST Countries API.

## Features

- Get a count of books available in a specified language.
- Determine the number of potential readers for a given language.
- Health check status for the web service and external APIs it depends on.

## Getting Started

### Prerequisites

- Go (Golang) installed on your machine ([installation guide](https://golang.org/doc/install))
- Postman or curl for testing endpoints locally

### Installation

Clone the repository to your local machine:

```sh
git clone https://git.gvk.idi.ntnu.no/ab/assignment1.git
cd assignment1
```

### Running the Service

To run the service locally, navigate to the project directory and execute:

```sh
go run main.go
```

This will start the server on `localhost:8080`. Ensure there are no errors in the terminal indicating the server has started successfully.

### Testing the Endpoints

You can test the endpoints using `curl` or Postman. Here are examples using `curl`:

- **Get Book Count**:

  ```sh
  curl "http://127.0.0.1:8080/librarystats/v1/bookcount/?language=en"
  ```

- **Get Readership**:

  ```sh
  curl "http://127.0.0.1:8080/librarystats/v1/readership/en"
  ```

- **Service Status**:

  ```sh
  curl "http://127.0.0.1:8080/librarystats/v1/status/"
  ```

Replace `en` with the desired ISO 639-1 language code as needed.

### Deployment

The final web service should be deployed on Render. Follow the instructions provided in the course material or Render's documentation to deploy your Go application. Ensure to set the correct environment variables and configurations as required by your application and external services it depends on.
